#include "Rectangle.h"
//Serial pc(USBTX, USBRX);

//////////////COLLISIONLEFTUPS - RECTANGLE//////////////////////////////////////////////////
/**
@details collision condition between given object and passed object
* (This function is when passed object has origins point at top left corner)
*/
bool Rectangle::collisionLeftUpS(Rectangle a)
{
    if (y==(a.y-1))
    {
        if (((x+width-1)>=a.x)&&(x<=(a.x+a.width-1)))
        {
            return true;
        }
    }
    return false;
}    

//////////////COLLISIONLEFTUPN - RECTANGLE//////////////////////////////////////////////////
/**
@details collision condition between given object and passed object
* (This function is when passed object has origins point at top left corner)
*/
bool Rectangle::collisionLeftUpN(Rectangle a)
{
    if ((y-height+1)==(a.y+a.height))
    {
        if (((x+width-1)>=a.x)&&(x<=(a.x+a.width-1)))
        {
            //pc.printf("Collision S\n");
            //pc.printf("x - %d width - %d y - %d height - %d\n", x, width, y, height);
            //pc.printf("Ax - %d width - %d y - %d height - %d\n", a.x, a.width, a.y, a.height);
            return true;
        }
    }
    return false;
}

//////////////COLLISIONLEFTUPW - RECTANGLE//////////////////////////////////////////////////
/**
@details collision condition between given object and passed object
* (This function is when passed object has origins point at top left corner)
*/
bool Rectangle::collisionLeftUpW(Rectangle a)
{
    if (x==(a.x+a.width))
    {
        if ((y>=a.y)&&((y-height+1)<=(a.y+a.height-1)))
        {
            return true;
        }
    }
    return false;
}

//////////////COLLISIONLEFTUPE - RECTANGLE//////////////////////////////////////////////////
/**
@details collision condition between given object and passed object
* (This function is when passed object has origins point at top left corner)
*/
bool Rectangle::collisionLeftUpE(Rectangle a)
{
    if ((x+width)==(a.x))
    {
        if ((y>=a.y)&&((y-height+1)<=(a.y+a.height-1)))
        {
            return true;
        }
    }
    return false;
}

//////////////TOUCHLEFTDOWNN - RECTANGLE//////////////////////////////////////////////////
/**
@details touching condition between given object and passed object
* (This function is when passed object has origins point at bottom left down)
*/
bool Rectangle::touchLeftDownN(Rectangle a)
{
    if((y-height+1)==a.y)
    {
        if(((x+width-1)>=a.x)&&(x<=(a.x+a.width-1)))
        {
            return true;
        }   
    }
    return false;
}

//////////////TOUCHLEFTDOWNS - RECTANGLE//////////////////////////////////////////////////
/**
@details touching condition given object and passed object
* (This function is when passed object has origins point at bottom left down)
*/
bool Rectangle::touchLeftDownS(Rectangle a)
{
    if(y==(a.y-a.height+1))
    {
        if(((x+width-1)>=a.x)&&(x<=(a.x+a.width-1)))
        {
            return true;
        }
    }
    return false;
}

//////////////TOUCHLEFTDOWNW - RECTANGLE//////////////////////////////////////////////////
/**
@details touching condition given object and passed object
* (This function is when passed object has origins point at bottom left down)
*/
bool Rectangle::touchLeftDownW(Rectangle a)
{
    if(x==(a.x+a.width-1))
    {
        if(((y-height+1)<=a.y)&&(y>=(a.y-a.height+1)))
        {
            return true;
        }
    }
    return false;
}

//////////////TOUCHLEFTDOWNE - RECTANGLE//////////////////////////////////////////////////
/**
@details touching condition given object and passed object
* (This function is when passed object has origins point at bottom left down)
*/
bool Rectangle::touchLeftDownE(Rectangle a)
{
    if(x+width-1==a.x)
    {
        if(((y-height+1)<=a.y)&&(y>=(a.y-a.height+1)))
        {
            return true;
        }   
    }
    return false;
}

//getter of variable X
int Rectangle::getX()
{
    return x;       
}

//getter of variable Y
int Rectangle::getY()
{    
    return y;   
}

//getter of variable Width
int Rectangle::getWidth()
{
    return width;          
}

//getter of variable Height
int Rectangle::getHeight()
{
    return height;                
}